package com.example.ellegadodepintia.exploradoresDePintia.model.efecto

import com.example.ellegadodepintia.R
import com.example.ellegadodepintia.exploradoresDePintia.model.GameState
import com.example.ellegadodepintia.exploradoresDePintia.model.GestorCombate
import com.example.ellegadodepintia.exploradoresDePintia.model.Atributo
import com.example.ellegadodepintia.exploradoresDePintia.model.eventoFactory.EventoCombate
import com.example.ellegadodepintia.soundManager.SoundManager

class EfectoAtaqueEnemigo(probabilidadExito: Int) : Efecto(probabilidadExito) {
    private lateinit var soundManager: SoundManager
    override fun ejecutar(): String {
        val probabilidadEnemigo = (1..100).random()
        val mensaje: String
        soundManager = SoundManager(GameState.context!!)
        val evento = GameState.eventoActual as? EventoCombate ?: return "No es un evento de combate"
        GestorCombate.cargarAnimacionesAtaqueEnemigo()

        if (probabilidadEnemigo <= probabilidadExito) {
            val ataqueReal = GestorCombate.calcularAtaque(evento.ataque, evento.probCritico)

            GameState.jugador.actualizarAtributo(Atributo.Vida, -ataqueReal)
            soundManager.playSound(R.raw.sound_golpe1,100)
            mensaje = "¡El enemigo te ha golpeado, recibes $ataqueReal de daño!"
        } else {
            mensaje = "¡El enemigo ha fallado el golpe!"
            soundManager.playSound(R.raw.sound_miss,100)
        }

        return mensaje
    }
}