package com.example.ellegadodepintia.exploradoresDePintia.model.habilidad.efectoHabilidad

import android.os.Handler
import android.os.Looper
import com.example.ellegadodepintia.R
import com.example.ellegadodepintia.exploradoresDePintia.model.Atributo
import com.example.ellegadodepintia.exploradoresDePintia.model.GameState
import com.example.ellegadodepintia.exploradoresDePintia.model.GameState.context
import com.example.ellegadodepintia.exploradoresDePintia.model.LayoutUtils
import java.util.UUID
import com.example.ellegadodepintia.soundManager.SoundManager

class EfectoBuffo(private val atributo: Atributo, private val poder: Int, private var turnos: Int) :

    EfectoHabilidad() {
    private var id: String = UUID.randomUUID().toString()

    override fun ejecutar() {
        var soundManager: SoundManager
        soundManager = SoundManager(context!!)
        soundManager.playSound(R.raw.sound_habilidad, 100)
        GameState.jugador.actualizarAtributo(atributo, poder)
        GameState.jugador.actualizarBuffo(this.clonar())
    }

    fun eliminarBuffo() {
        Handler(Looper.getMainLooper()).postDelayed({
            GameState.jugador.actualizarAtributo(atributo, -poder)
            GameState.jugador.eliminarBuffo(this)
        },200)
    }

    fun pasarTurno(){
        turnos-=1
        println("$id $turnos")
        if(turnos<=0){
            eliminarBuffo()
        }
    }

    override fun equals(other: Any?): Boolean {
        return other is EfectoBuffo && other.id == this.id
    }

    override fun hashCode(): Int {
        return id.hashCode()
    }

    fun clonar(): EfectoBuffo {
        return EfectoBuffo(this.atributo, this.poder, this.turnos)
    }


}